import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;


public class EvaluationExtrinsic {
	
	static ArrayList<String> sentences;
	static ArrayList<String> sentences2;
	
	
	public static ArrayList<HashMap<Integer,ArrayList<String>>> loadCorpus(String file){
		ArrayList<HashMap<Integer,ArrayList<String>>> out=new ArrayList<HashMap<Integer,ArrayList<String>>>();
		sentences2=new ArrayList<String>();
		try {
			BufferedReader br=new BufferedReader(new FileReader(file));
			HashMap<Integer, ArrayList<String>> mapsent=new HashMap<Integer, ArrayList<String>>();
			
			int c=0;
			while(br.ready()){
				String line=br.readLine();
				if (line.isEmpty()) {
					out.add(c,mapsent);
					c++;
					mapsent=new HashMap<Integer, ArrayList<String>>();
				}
				else if (line.startsWith("[")){
					String nline=line.replaceAll("\\[","").replaceAll("\\]", "");
					
					String[] split=nline.split(",");
					for(int i=0;i<split.length;i++){
						String[] spw=split[i].split(":");
						ArrayList<String> suggs=new ArrayList<String>();
						if (spw.length>1){
							String[] suggSpl=spw[1].split(";");
							for (int j=0;j<suggSpl.length;j++){
								suggs.add(suggSpl[j].toLowerCase());
							}
							mapsent.put(Integer.parseInt(spw[0]),suggs);
						}
					}
					
				}
				else {
					sentences2.add(c, line.toLowerCase().trim());
				}

			}
			br.close();
			System.out.println(c);
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
		return out;
	}
	
	
	
	public static ArrayList<HashMap<Integer,ArrayList<String>>> loadSystem(String file){
		ArrayList<HashMap<Integer,ArrayList<String>>> out=new ArrayList<HashMap<Integer,ArrayList<String>>>();
		sentences2=new ArrayList<String>();
		try {
			BufferedReader br=new BufferedReader(new FileReader(file));
			HashMap<Integer, ArrayList<String>> mapsent=new HashMap<Integer, ArrayList<String>>();
			
			int c=0;
			while(br.ready()){
				String line=br.readLine();
				if (line.isEmpty()) {
					out.add(c,mapsent);
					c++;
					mapsent=new HashMap<Integer, ArrayList<String>>();
				}
				else if (line.startsWith("{")){
					String nline=line.replaceAll("\\{","").replaceAll("\\}", "").replaceAll(" ","");
					
					String[] split=nline.split(",");
					for(int i=0;i<split.length;i++){
						String[] spw=split[i].split("=");
						ArrayList<String> suggs=new ArrayList<String>();
						if (spw.length>1){
							String[] suggSpl=spw[1].replaceAll("\\[","").replaceAll("\\]","").split(",");
							for (int j=0;j<suggSpl.length;j++){
								suggs.add(suggSpl[j].toLowerCase());
							}
							mapsent.put(Integer.parseInt(spw[0]),suggs);
						}
					}
					
				}
				else {
					sentences2.add(c, line.toLowerCase().trim());
				}

			}
			br.close();
			System.out.println(c);
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
		return out;
	}
	
	
	public static ArrayList<HashMap<Integer,String>> loadGold(String file){
		
		ArrayList<HashMap<Integer,String>> gold=new ArrayList<HashMap<Integer,String>>();
		sentences=new ArrayList<String>();
		try {
			BufferedReader br=new BufferedReader(new FileReader(file));
			HashMap<Integer, String> mapsent=new HashMap<Integer, String>();
			
			int c=0;
			while(br.ready()){
				String line=br.readLine();
				if (line.isEmpty()) {
					gold.add(c,mapsent);
					c++;
					mapsent=new HashMap<Integer, String>();
				}
				else if (line.startsWith("[")){
					String nline=line.replaceAll("\\[","").replaceAll("\\]", "");
					
					String[] split=nline.split(",");
					for(int i=0;i<split.length;i++){
						String[] spw=split[i].split(":");
						if (spw.length>1){
							mapsent.put(Integer.parseInt(spw[0]),spw[1].toLowerCase());
						}
					}
					
				}
				else {
					sentences.add(c, line.toLowerCase().trim());
				}
				
			}
			System.out.println(c);
			br.close();
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
		return gold;
	}
	

	
	public static void main23424 (String[] args){
		
		
		int tp=0;
		int fp=0;
		int tn=0;
		int fn=0;
		
		int errorsTP=0;
		int errorsFP=0;
		int errorsTN=0;
		int errorsFN=0;

		ArrayList<HashMap<Integer,ArrayList<String>>> system=Evaluation.loadCorpus(args[1]);
		//ArrayList<HashMap<Integer,ArrayList<String>>> system=EvaluationExtrinsic.loadSystem(args[1]);
		ArrayList<HashMap<Integer,String>> gold=EvaluationExtrinsic.loadGold(args[0]);

		System.out.println(sentences);
		System.out.println(sentences2);
		for (int z=0;z<gold.size();z++){

			HashMap<Integer,ArrayList<String>> output3=system.get(z);

			HashMap<Integer,String> sols=gold.get(z);
			System.out.println("sentence1:"+sentences.get(z));
			System.out.println("sentence2:"+sentences2.get(z));
			System.out.println("gold"+sols);
			System.out.println("sys:"+output3);
			
			
			String line=sentences.get(z);
			
			
			Iterator<Integer> it=sols.keySet().iterator();
			/*while(it.hasNext()){
				Integer wi=it.next();
				String sugg=sols.get(wi);
				System.out.println(wi);
				if (output3.get(wi)!=null){
					if (output3.get(wi).contains(sugg)){
						tp++;
						//System.out.println(output3);
					}
					else {
						fp++;
					}
				}
				else {
					fn++;
				}
			}*/
			String[]tokens=line.split(" ");
			for (int i=0;i<tokens.length;i++){
				if (!sols.containsKey(i) && !output3.containsKey(i)){
					tn++;
					errorsTN++;
				}
				else {
					if (!sols.containsKey(i) && output3.containsKey(i)){
						errorsFP++;
						
					}
					else if (sols.containsKey(i) && output3.containsKey(i)){
						errorsTP++;
						
					}
					else if (sols.containsKey(i) && !output3.containsKey(i)){
						
						errorsFN++;
					}
				}
			}
		}
		
		System.out.println("------------------------------------------------------------------------------------------");
		
		System.out.println("Suggestion.tp:"+tp);
		System.out.println("Suggestion.fp:"+fp);
		System.out.println("Suggestion.tn:"+tn);
		System.out.println("Suggestion.fn:"+fn);
		double P=(double)tp/((double)tp+(double)fp)*100;
		double R=(double)tp/((double)tp+(double)fn)*100;
		System.out.println("Suggestion.P:"+P);
		System.out.println("Suggestion.R:"+R);
		double F1=(2*(double)tp)/(2*(double)tp+(double)fp+(double)fn)*100;
		System.out.println("Suggestion.F1:"+F1);
		System.out.println("*******");
		
		System.out.println("ErrorDetection.tp:"+errorsTP);
		System.out.println("ErrorDetection.fp:"+errorsFP);
		System.out.println("ErrorDetection.tn:"+errorsTN);
		System.out.println("ErrorDetection.fn:"+errorsFN);
		double errorsP=(double)errorsTP/((double)errorsTP+(double)errorsFP)*100;
		double errorsR=(double)errorsTP/((double)errorsTP+(double)errorsFN)*100;
		
		System.out.println("ErrorDetection.P:"+errorsP);
		System.out.println("ErrorDetection.R:"+errorsR);
		
		double errorsF1=(2*(double)errorsTP)/(2*(double)errorsTP+(double)errorsFP+(double)errorsFN)*100;
		
		System.out.println("ErrorDetection.F1:"+errorsF1);
	}
	
	
	public static void main (String[] args){
		
		
		int tp=0;
		int fp=0;
		int tn=0;
		int fn=0;
		
		int errorsTP=0;
		int errorsFP=0;
		int errorsTN=0;
		int errorsFN=0;

		ArrayList<HashMap<Integer,ArrayList<String>>> system=EvaluationExtrinsic.loadCorpus(args[1]);
		//ArrayList<HashMap<Integer,ArrayList<String>>> system=EvaluationExtrinsic.loadSystem(args[1]);
		ArrayList<HashMap<Integer,String>> gold=EvaluationExtrinsic.loadGold(args[0]);

		System.out.println("Gold:"+sentences);
		System.out.println("Outs:"+sentences2);
		for (int z=0;z<gold.size();z++){

			HashMap<Integer,ArrayList<String>> output3=system.get(z);

			HashMap<Integer,String> sols=gold.get(z);
			System.out.println("gold"+sols);
			System.out.println("sys:"+output3);
			
			
			String line=sentences.get(z);
			
			
			Iterator<Integer> it=sols.keySet().iterator();
			/*while(it.hasNext()){
				Integer wi=it.next();
				String sugg=sols.get(wi);
				if (output3.get(wi)!=null){
					if (output3.get(wi).contains(sugg)){
						tp++;
					}
					else {
						fp++;
					}
				}
				else {
					fn++;
				}
			}*/
			String[] tokens=line.split(" ");
			for (int i=0;i<tokens.length;i++){
				if (!sols.containsKey(i) && !output3.containsKey(i)){
					tn++;
					errorsTN++;
				}
				else {
					if (!sols.containsKey(i) && output3.containsKey(i)){
						errorsFP++;
						fp+=output3.get(i).size();
					}
					else if (sols.containsKey(i) && output3.containsKey(i)){
						errorsTP++;
						if (output3.get(i).contains(sols.get(i))){
							tp++;
							if (output3.get(i).size()>1) fp+=output3.get(i).size()-1;
						}
						else {
							fp+=output3.get(i).size();
						}
					}
					else if (sols.containsKey(i) && !output3.containsKey(i)){
						errorsFN++;
						fn++;
					}
				}
			}
		}
		
		System.out.println("------------------------------------------------------------------------------------------");
		
		System.out.println("Suggestion.tp:"+tp);
		System.out.println("Suggestion.fp:"+fp);
		System.out.println("Suggestion.tn:"+tn);
		System.out.println("Suggestion.fn:"+fn);
		
		double F1=(2*(double)tp)/(2*(double)tp+(double)fp+(double)fn)*100;
		double P=(double)tp/((double)tp+(double)fp)*100;
		double R=(double)tp/((double)tp+(double)fn)*100;
		
		System.out.println("Suggestion.P:"+P);
		System.out.println("Suggestion.R:"+R);
		System.out.println("Suggestion.F1:"+F1);
		System.out.println("*******");
		
		System.out.println("ErrorDetection.tp:"+errorsTP);
		System.out.println("ErrorDetection.fp:"+errorsFP);
		System.out.println("ErrorDetection.tn:"+errorsTN);
		System.out.println("ErrorDetection.fn:"+errorsFN);
		
		double errorsF1=(2*(double)errorsTP)/(2*(double)errorsTP+(double)errorsFP+(double)errorsFN)*100;
		double errorsP=(double)errorsTP/((double)errorsTP+(double)errorsFP)*100;
		double errorsR=(double)errorsTP/((double)errorsTP+(double)errorsFN)*100;
		
		System.out.println("ErrorDetection.P:"+errorsP);
		System.out.println("ErrorDetection.R:"+errorsR);

		System.out.println("ErrorDetection.F1:"+errorsF1);
	}
	


}
