

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.InetSocketAddress;
import java.net.URL;
import java.net.URLDecoder;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.apache.http.client.utils.URLEncodedUtils;
import org.omg.DynamicAny.NameValuePair;

import com.google.appengine.repackaged.com.google.common.base.Splitter;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;



public class Server {

	static Corrector corrector;

	static long ids =0;

	public static void main(String[] args) throws Exception {
		HttpServer server = HttpServer.create(new InetSocketAddress(8000), 0);
		server.createContext("/", new MyHandler());
		//server.createContext("/image", new ImageHandler());
		server.createContext("/parse", new DefaultHandler());

		//		server.setExecutor(null); // creates a default executor
		int port = server.getAddress().getPort();
		System.out.println("Start server: http://localhost:"+port);

		//corrector= new Corrector(args[0],args[1],args[2],args[3],args[4],args[5]);
		server.start();
	}

	static class MyHandler implements HttpHandler {
		public void handle(HttpExchange t) throws IOException {
			// get the initial form 
			StringBuffer sb = new StringBuffer();
			sb.append("<HTML><HEAD></HEAD><BODY>");
			sb.append(getForm());
			sb.append(getEndOfPage());
			t.sendResponseHeaders(200, sb.length());
			OutputStream os = t.getResponseBody();
			os.write(sb.toString().getBytes());
			os.close();
		}
	} 

	public static StringBuffer getForm() {
		StringBuffer sb =new StringBuffer();
		sb.append("<form action=\"/parse\" method=\"POST\">\n");
		sb.append("<textarea name=\"sentence\" cols=80 rows=2></textarea>\n");
		sb.append("<input type=\"submit\" value=\"Check text\" /> \n");
		sb.append("</form>\n");
		return sb;		
	}
	public static StringBuffer getEndOfPage() {
		StringBuffer sb =new StringBuffer();
		sb.append("</BODY></HTML>");
		return sb;		
	}
	

	
	static class DefaultHandler  implements HttpHandler {

		@Override
		public void handle(HttpExchange exchange) throws IOException {

			
			
			
			Map<String,String> vars=contentToVariableMap(getContent(exchange));
			System.out.println(vars);
			String inputSentence=vars.get("sentence");

			//corrector.runCorrector(inputSentence);
			System.out.println(inputSentence);
			

			String httpResponse ="";
			//			httpResponse +=lines[0].append("<br>").toString(); 
			//			httpResponse +=lines[1].append("<br>").toString(); 
			//			httpResponse +=lines[2].append("<br>").toString(); 

			// get the initial form 
			StringBuffer sb = new StringBuffer();

			sb.append("<HTML><HEAD></HEAD><BODY>\n");

			String id = ""+ids++;
			
			//sb.append("<img src=\"/image/"+id+".jpg\"/><br>\n");
			sb.append(httpResponse);
			sb.append(getForm());
			sb.append(getEndOfPage());
			sendContent(exchange,sb.toString(),"text/html",200);
			OutputStream os = exchange.getResponseBody();
			os.write(sb.toString().getBytes());
			os.close();
			exchange.sendResponseHeaders(200, sb.length());				
			System.out.println("called again");
		}
	}

	public static String getContent(HttpExchange exchange) throws IOException {

		BufferedReader httpInput=new BufferedReader(
				new InputStreamReader(exchange.getRequestBody(),"UTF-8"));
		StringBuilder in=new StringBuilder();
		String input;
		while((input=httpInput.readLine())!=null) 
			in.append(input).append(" ");

		httpInput.close();
		return in.toString().trim();
	}

	public static  Map<String,String> contentToVariableMap(String content) throws IOException {
		Map<String,String> ret=new HashMap<String,String>();
		String[] pairs=content.split("&");
		for(String pair:pairs){
			String[] a=pair.split("=");
			ret.put(URLDecoder.decode(a[0],"UTF-8"),URLDecoder.decode(a[1],"UTF-8"));
		}
		return ret;
	}

	public static  void sendContent(HttpExchange exchange,String content,String content_type,
			int responseCode) throws IOException{
		exchange.getResponseHeaders().add("Content-type",content_type);
		byte[] bytes=content.getBytes("UTF-8");
		exchange.sendResponseHeaders(200,bytes.length);
		OutputStream os=new BufferedOutputStream(exchange.getResponseBody());
		os.write(bytes);
		os.close();
	}
}
