/**
 * 
 */
package confusionSets;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

import com.BoxOfC.LevenshteinAutomaton.LevenshteinAutomaton;

/**
 *
 *
 */
public class ConfSetsGenerator {

	HashMap<String,LinkedList<String>> confSets;
	
	HashMap<String,ArrayList<String>> hashDictionary;
	ArrayList<String> listDictionary;
	
	String dictionary;
	
	
	
	public ConfSetsGenerator(String dictionary){
		
		this.dictionary=dictionary;
		listDictionary=new ArrayList<String>();
		hashDictionary=new HashMap<String,ArrayList<String>>();
		
		try {
			BufferedReader br=new BufferedReader(new FileReader(dictionary));
			while(br.ready()){
				
				String word=br.readLine();
				
				word=word.toLowerCase();
				ArrayList<String> dictPerLength;
				
				String key=word.length()+word.substring(0,1);
				//System.out.println(key);
				if (!hashDictionary.containsKey(key)){
					dictPerLength=new ArrayList<String>();
				}
				else {
					dictPerLength=hashDictionary.get(key);
				}
				
				if (!dictPerLength.contains(word)) {
					listDictionary.add(word);
					dictPerLength.add(word);
				}
				
				hashDictionary.put(key, dictPerLength);
				
				
			}
			
			br.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//System.out.println(hashDictionary);
		
		confSets=new HashMap<String,LinkedList<String>>();
		
	}
	
	public void inDictionary(String file){
		try{
		BufferedReader br=new BufferedReader(new FileReader(file));
			while(br.ready()){
				String line=br.readLine();
				if (listDictionary.contains(line)) System.out.println(line);
			}
		}catch(Exception e){
			
		}
	}
	
	public void test(){
		ArrayList<String> empty=new ArrayList<String>();
		System.out.println(permStr("casa"));
		
	}
	
	
	/**
	 * This method generates all possible permutations of a string.
	 * @param str
	 * @return
	 */
	private Vector<String> permStr(String str){

	    if (str.length() == 1){
	        Vector<String> ret = new Vector<String>();
	        ret.add(str);
	        return ret;
	    }
	    char start = str.charAt(0);
	    Vector<String> endStrs = permStr(str.substring(1));
	    Vector<String> newEndStrs = new Vector<String>();
	    for (String endStr : endStrs){
	        for (int j = 0; j <= endStr.length(); j++){
	            if (endStr.substring(0, j).endsWith(String.valueOf(start)))
	                break;
	            newEndStrs.add(endStr.substring(0, j) + String.valueOf(start) + endStr.substring(j));
	        }
	    }
	    return newEndStrs;
	}
	
	private  ArrayList<String> allSubstrings(String word) {
		ArrayList<String> aux=new ArrayList<String>();
	    for (int from = 0; from < word.length(); from++) {
	        for (int to = from + 1; to <= word.length(); to++) {
	            if (!word.equals(word.substring(from, to))) aux.add(word.substring(from, to));
	        }
	    }
	    return aux;
	}
	
	
	
	private LinkedList<String> allPairs(ArrayList<String> list, int length) {
		
		LinkedList<String> out=new LinkedList<String>();
		for (int i=0;i<list.size()-1;i++){
			for (int j=0;j<list.size();j++){
				if (i!=j){
					String cand=list.get(i)+" "+list.get(j);
					if (cand.length()==length+1){
						out.add(list.get(i)+" "+list.get(j));
					}
				}
			}
		}
	    return out;
	}


	
	
	
	
	
	
	public void generate(){
		
		
		
		Iterator<String> itDict=listDictionary.iterator();
		
		
		while(itDict.hasNext()){
			
			String word=itDict.next();
			//String word="casa";
			if (word.length()>=14){
				System.out.println();
				System.out.println("Word:"+word);
					
				//rules level 1
				if (word.length()>=1) {
					LinkedList<String> neighbors1 = LevenshteinAutomaton.fuzzySearchNonAutomaton(1, word, listDictionary);
					neighbors1.remove(word);
					
					
					System.out.println("Lev: 1:"+neighbors1);
					
					
					if (!confSets.containsKey(word)){
						confSets.put(word, neighbors1);
					}
					else {
						LinkedList<String> aux=confSets.get(word);
						aux.addAll(neighbors1);
						confSets.put(word, aux);
					}
				}
				
				//rules level 2
				
				if (word.length()>4){
					LinkedList<String> neighbors2 = LevenshteinAutomaton.fuzzySearchNonAutomaton(2, word, listDictionary);
					neighbors2.remove(word);
					System.out.println("Lev: 2:"+neighbors2);
					
					if (!confSets.containsKey(word)){
						confSets.put(word, neighbors2);
					}
					else {
						LinkedList<String> aux=confSets.get(word);
						aux.addAll(neighbors2);
						confSets.put(word, aux);
					}
				}
				
				//rules anagramas
				
				if (word.length()<9){
				
					Vector<String> anagrams=this.permStr(word);
					LinkedList<String> neighborsAnagrams =new LinkedList<String>();
					
					//System.out.println(anagrams.size());
					
					Iterator<String> it=anagrams.iterator();
					//int cont=0;
					while(it.hasNext()){
						String anagram=it.next();
						if (!anagram.equals(word)){
							ArrayList<String> selectedDictionary=hashDictionary.get(anagram.length()+""+anagram.substring(0,1));
							//System.out.println(selectedDictionary);
							if (selectedDictionary!=null) {
								if (selectedDictionary.contains(anagram)) neighborsAnagrams.add(anagram);
							}
						}
						//cont++;
						//if (cont%10000==0) System.out.println(cont);
					}
					
					
					System.out.println("Anagramas:"+neighborsAnagrams);
					
					
					if (!confSets.containsKey(word)){
						confSets.put(word, neighborsAnagrams);
					}
					else {
						LinkedList<String> aux=confSets.get(word);
						aux.addAll(neighborsAnagrams);
						confSets.put(word, aux);
					}
				}
				
				//rules subwords
				
				ArrayList<String> subStrings=allSubstrings(word);
				ArrayList<String> subWords=new ArrayList<String>();
				Iterator<String> itS=subStrings.iterator();
				while(itS.hasNext()){
					String w=itS.next();
					ArrayList<String> selectedDictionary=hashDictionary.get(w.length()+""+w.substring(0,1));
					//System.out.println(selectedDictionary);
					if (selectedDictionary!=null) {
						if (selectedDictionary.contains(w)) subWords.add(w);
					}
				}
				LinkedList<String> combWords=this.allPairs(subWords, word.length());
				if (!confSets.containsKey(word)){
					confSets.put(word, combWords);
				}
				else {
					LinkedList<String> aux=confSets.get(word);
					aux.addAll(combWords);
					confSets.put(word, aux);
				}
				System.out.println("Combined:"+ combWords);
				
				/*String wordSpace=word+" ";
				
				LinkedList<String> neighborsSpace = LevenshteinAutomaton.fuzzySearchNonAutomaton(1, wordSpace, listDictionary);
				neighborsSpace.remove(word);
				
				LinkedList<String> neighborsSpaceValid=new LinkedList<String>();
				
				
				
				
				System.out.println("Lev: 1:"+neighborsSpaceValid);
				
				
				if (!confSets.containsKey(word)){
					confSets.put(word, neighborsSpaceValid);
				}
				else {
					LinkedList<String> aux=confSets.get(word);
					aux.addAll(neighborsSpaceValid);
					confSets.put(word, aux);
				}*/
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
			}
			
		}
		//System.out.println(confSets);

		
		
		
	}
	
	public static void main(String[] args) {
		//System.out.println(ConfSetsGenerator.allSubstrings("aviador"));
		//System.out.println(ConfSetsGenerator.allPairs(ConfSetsGenerator.allSubstrings("aviador")));
		
		ConfSetsGenerator csg=new ConfSetsGenerator(args[0]);
		csg.inDictionary("/home/miguel/Downloads/is_it_a_word.txt");
		//csg.generate();
		
		
		//csg.test();
	}
	
}
